; these are tables of values for defining object locations
; sizes of tables = maxobjects

        extrn xs:dword,    ys:dword,    zs:dword
        extrn xadds:dword, yadds:dword, zadds:dword
        extrn vxs:word,    vys:word,    vzs:word
        extrn vxadds:word, vyadds:word, vzadds:word
        extrn lcount:word, acount:word
        extrn xsfinal:dword,    ysfinal:dword,    zsfinal:dword
        extrn vxsfinal:word,    vysfinal:word,    vzsfinal:word
        extrn whatshape:word,   userotate:byte,   onoff:byte

; these are single values for defining the camera location

        extrn eyex:dword,     eyey:dword,     eyez:dword
        extrn eyeax:word,     eyeay:word,     eyeaz:word
        extrn eyexadds:dword, eyeyadds:dword, eyezadds:dword
        extrn eyevxadds:word, eyevyadds:word, eyevzadds:word
        extrn eyelcount:word, eyeacount:word

; misc data

        extrn background:word

        extrn vmatrix:word
        extrn tmatrix:word
        extrn ematrix:dword
        extrn lmatrix:word
        extrn y_angle_of_sun:word

        extrn use_clear:word
        extrn wfollow:word
        extrn wherelook:word

; for scale routine

        extrn bitmap:dword
        extrn destwidth:word
        extrn destheight:word
        extrn destx:word
        extrn desty:word

; for fakeline routine

        extrn x1:word
        extrn y1:word
        extrn x2:word
        extrn y2:word

; for calling poly_fill (after calling fakeline)

        extrn colq:byte
        extrn steel:byte

; for windowing

        extrn lxupdate:word
        extrn lyupdate:word
        extrn xupdate:word
        extrn yupdate:word
        extrn makeorder:word
        extrn oney:word
        extrn firstbyte:word
        extrn lastbyte:word
        extrn showing:word

; misc routines from 3d.asm and poly.inc

        extrn flip_page:near
        extrn initpages:near
        extrn flip_page:near
        extrn fakeline:near
        extrn poly_fill:near
        extrn clear_fill:near
        extrn move_si:near
        extrn twist_si:near
        extrn newfollow:near
        extrn resetupd:near
        extrn updvectors:near
        extrn makeobjs:near
        extrn make1obj:near
        extrn setsincose:near
        extrn look_at_it:near
        extrn calc_angles:near
        extrn calc_middle:near
        extrn get_displacement:near
        extrn put_object:near
        extrn set_angle:near
        extrn set_shape:near
        extrn set_object_on:near
        extrn set_object_off:near
        extrn init_tables:near
        extrn flush_surfaces:near
        extrn clipped_line:near
        extrn set_clip_absolute:near
        extrn set_clip_offset:near
        extrn drawvect:near
        extrn sort_list:near
        extrn set_finall:near
        extrn set_finala:near
        extrn point_it:near
        extrn point_dir:near
        extrn point_to:near
        extrn set_speed:near
        extrn point_time:near
        extrn nullpalette:dword
        extrn set_xref_palette:near

; poly.inc - fast imul table, eg: screen_width*si = fastimultable[si]

        extrn fastimultable:word

; xscale1.inc

        extrn xscale1:near
        extrn xscale2:near
        extrn xscale4:near
        extrn draw_scale:near
        extrn tdraw_scale:near
        extrn tdraw_scale4:near
        extrn repeat_bitmap:near

; math.inc

        extrn make3d:near
        extrn erotate:near
        extrn rotate:near
        extrn rotatenull:near
        extrn arctan:near
        extrn cosign:near
        extrn sign:near
        extrn setsincose:near
        extrn compound:near
        extrn sqrt:near
        extrn sqrax2bx2:near
        extrn set_precal7:near
        extrn set_precal147:near
        extrn frotate:near
        extrn fzsolve:near
        extrn z16x:near
        extrn z16z:near
        extrn temp_matrix:near
        extrn matrix_multiply:near

        extrn precal1:dword
        extrn precal4:dword
        extrn precal7:dword

        extrn xcent
        extrn ycent
        extrn xmins
        extrn xmins1
        extrn xmaxs
        extrn xmaxs1
        extrn ymins
        extrn ymins1
        extrn ymaxs
        extrn ymaxs1

        extrn lambert:near
        extrn pre_cal_lambert:near
        extrn calc_normal:near
        extrn set_up_all_lambert:near
        extrn lrotate:near

        extrn lx1:dword
        extrn ly1:dword
        extrn lz1:dword
        extrn lx2:dword
        extrn ly2:dword
        extrn lz2:dword
        extrn lx3:dword
        extrn ly3:dword
        extrn lz3:dword

; list of current assembley restraints - can be used to test if object file
; was assembled with ample room/size of tables.

        extrn asm_maxpoints:word
        extrn asm_maxsurfaces:word
        extrn asm_maxpolys:word
        extrn asm_maxobjects:word
        extrn asm_number_spaces:word
        extrn asm_xsize:word
        extrn asm_ysize:word
        extrn asm_usez:word
        extrn asm_useborders:word
        extrn asm_use_half_stars:word
        extrn asm_cameraobject:word
        extrn asm_xmode:word
        extrn asm_ratiox:word
        extrn asm_ratioy:word
        extrn asm_xactual:word
        extrn asm_yactual:word
        extrn asm_pages:word

